(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["index"] = factory();
	else
		root["index"] = factory();
})((typeof self !== 'undefined' ? self : this), function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "fb15");
/******/ })
/************************************************************************/
/******/ ({

/***/ "20ce":
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__("cf02");
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var update = __webpack_require__("499e")("796f3664", content, true, {"sourceMap":false,"shadowMode":false});

/***/ }),

/***/ "2350":
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),

/***/ "499e":
/***/ (function(module, exports, __webpack_require__) {

/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
  Modified by Evan You @yyx990803
*/

var hasDocument = typeof document !== 'undefined'

if (typeof DEBUG !== 'undefined' && DEBUG) {
  if (!hasDocument) {
    throw new Error(
    'vue-style-loader cannot be used in a non-browser environment. ' +
    "Use { target: 'node' } in your Webpack config to indicate a server-rendering environment."
  ) }
}

var listToStyles = __webpack_require__("9bbc")

/*
type StyleObject = {
  id: number;
  parts: Array<StyleObjectPart>
}

type StyleObjectPart = {
  css: string;
  media: string;
  sourceMap: ?string
}
*/

var stylesInDom = {/*
  [id: number]: {
    id: number,
    refs: number,
    parts: Array<(obj?: StyleObjectPart) => void>
  }
*/}

var head = hasDocument && (document.head || document.getElementsByTagName('head')[0])
var singletonElement = null
var singletonCounter = 0
var isProduction = false
var noop = function () {}
var options = null
var ssrIdKey = 'data-vue-ssr-id'

// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
// tags it will allow on a page
var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\b/.test(navigator.userAgent.toLowerCase())

module.exports = function (parentId, list, _isProduction, _options) {
  isProduction = _isProduction

  options = _options || {}

  var styles = listToStyles(parentId, list)
  addStylesToDom(styles)

  return function update (newList) {
    var mayRemove = []
    for (var i = 0; i < styles.length; i++) {
      var item = styles[i]
      var domStyle = stylesInDom[item.id]
      domStyle.refs--
      mayRemove.push(domStyle)
    }
    if (newList) {
      styles = listToStyles(parentId, newList)
      addStylesToDom(styles)
    } else {
      styles = []
    }
    for (var i = 0; i < mayRemove.length; i++) {
      var domStyle = mayRemove[i]
      if (domStyle.refs === 0) {
        for (var j = 0; j < domStyle.parts.length; j++) {
          domStyle.parts[j]()
        }
        delete stylesInDom[domStyle.id]
      }
    }
  }
}

function addStylesToDom (styles /* Array<StyleObject> */) {
  for (var i = 0; i < styles.length; i++) {
    var item = styles[i]
    var domStyle = stylesInDom[item.id]
    if (domStyle) {
      domStyle.refs++
      for (var j = 0; j < domStyle.parts.length; j++) {
        domStyle.parts[j](item.parts[j])
      }
      for (; j < item.parts.length; j++) {
        domStyle.parts.push(addStyle(item.parts[j]))
      }
      if (domStyle.parts.length > item.parts.length) {
        domStyle.parts.length = item.parts.length
      }
    } else {
      var parts = []
      for (var j = 0; j < item.parts.length; j++) {
        parts.push(addStyle(item.parts[j]))
      }
      stylesInDom[item.id] = { id: item.id, refs: 1, parts: parts }
    }
  }
}

function createStyleElement () {
  var styleElement = document.createElement('style')
  styleElement.type = 'text/css'
  head.appendChild(styleElement)
  return styleElement
}

function addStyle (obj /* StyleObjectPart */) {
  var update, remove
  var styleElement = document.querySelector('style[' + ssrIdKey + '~="' + obj.id + '"]')

  if (styleElement) {
    if (isProduction) {
      // has SSR styles and in production mode.
      // simply do nothing.
      return noop
    } else {
      // has SSR styles but in dev mode.
      // for some reason Chrome can't handle source map in server-rendered
      // style tags - source maps in <style> only works if the style tag is
      // created and inserted dynamically. So we remove the server rendered
      // styles and inject new ones.
      styleElement.parentNode.removeChild(styleElement)
    }
  }

  if (isOldIE) {
    // use singleton mode for IE9.
    var styleIndex = singletonCounter++
    styleElement = singletonElement || (singletonElement = createStyleElement())
    update = applyToSingletonTag.bind(null, styleElement, styleIndex, false)
    remove = applyToSingletonTag.bind(null, styleElement, styleIndex, true)
  } else {
    // use multi-style-tag mode in all other cases
    styleElement = createStyleElement()
    update = applyToTag.bind(null, styleElement)
    remove = function () {
      styleElement.parentNode.removeChild(styleElement)
    }
  }

  update(obj)

  return function updateStyle (newObj /* StyleObjectPart */) {
    if (newObj) {
      if (newObj.css === obj.css &&
          newObj.media === obj.media &&
          newObj.sourceMap === obj.sourceMap) {
        return
      }
      update(obj = newObj)
    } else {
      remove()
    }
  }
}

var replaceText = (function () {
  var textStore = []

  return function (index, replacement) {
    textStore[index] = replacement
    return textStore.filter(Boolean).join('\n')
  }
})()

function applyToSingletonTag (styleElement, index, remove, obj) {
  var css = remove ? '' : obj.css

  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = replaceText(index, css)
  } else {
    var cssNode = document.createTextNode(css)
    var childNodes = styleElement.childNodes
    if (childNodes[index]) styleElement.removeChild(childNodes[index])
    if (childNodes.length) {
      styleElement.insertBefore(cssNode, childNodes[index])
    } else {
      styleElement.appendChild(cssNode)
    }
  }
}

function applyToTag (styleElement, obj) {
  var css = obj.css
  var media = obj.media
  var sourceMap = obj.sourceMap

  if (media) {
    styleElement.setAttribute('media', media)
  }
  if (options.ssrId) {
    styleElement.setAttribute(ssrIdKey, obj.id)
  }

  if (sourceMap) {
    // https://developer.chrome.com/devtools/docs/javascript-debugging
    // this makes source maps inside style tags work properly in Chrome
    css += '\n/*# sourceURL=' + sourceMap.sources[0] + ' */'
    // http://stackoverflow.com/a/26603875
    css += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + ' */'
  }

  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = css
  } else {
    while (styleElement.firstChild) {
      styleElement.removeChild(styleElement.firstChild)
    }
    styleElement.appendChild(document.createTextNode(css))
  }
}


/***/ }),

/***/ "9bbc":
/***/ (function(module, exports) {

/**
 * Translates the list format produced by css-loader into something
 * easier to manipulate.
 */
module.exports = function listToStyles (parentId, list) {
  var styles = []
  var newStyles = {}
  for (var i = 0; i < list.length; i++) {
    var item = list[i]
    var id = item[0]
    var css = item[1]
    var media = item[2]
    var sourceMap = item[3]
    var part = {
      id: parentId + ':' + i,
      css: css,
      media: media,
      sourceMap: sourceMap
    }
    if (!newStyles[id]) {
      styles.push(newStyles[id] = { id: id, parts: [part] })
    } else {
      newStyles[id].parts.push(part)
    }
  }
  return styles
}


/***/ }),

/***/ "bc3b":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_running_number_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("20ce");
/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_running_number_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_running_number_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0__);
/* unused harmony reexport * */
 /* unused harmony default export */ var _unused_webpack_default_export = (_node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_lib_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_running_number_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0___default.a); 

/***/ }),

/***/ "cf02":
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__("2350")(false);
// imports


// module
exports.push([module.i, ".cjk-running-component,.cjk-running-container{overflow:hidden}.cjk-running-container:before{content:\"-\";display:block;float:left;position:relative;-webkit-box-sizing:border-box;box-sizing:border-box;width:0;height:1.25em;line-height:1.05em;text-align:right;-webkit-transition:width .3s;-o-transition:width .3s;transition:width .3s;overflow:hidden}.cjk-running-container.cjk-minus:before{width:.5em}.cjk-number-box{float:left;position:relative;-webkit-box-sizing:border-box;box-sizing:border-box;width:.8em;height:1.25em;-webkit-transition:width .3s;-o-transition:width .3s;transition:width .3s}.cjk-number-box.cjk-split:after{content:\",\";display:block;position:absolute;right:-.1em;bottom:.15em;z-index:3}.cjk-number-box.cjk-pointer:after{content:\".\";display:block;position:absolute;right:-.15em;bottom:.06em;z-index:3}.cjk-number-box>div{position:relative;width:100%;height:100%;overflow:hidden}.cjk-number-box>div,.cjk-running-area{-webkit-box-sizing:border-box;box-sizing:border-box}.cjk-running-area{list-style:none;position:absolute;width:.8em;height:13.75em;left:0;top:0;visibility:visible;-webkit-animation-timing-function:linear;animation-timing-function:linear;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards;-webkit-animation-play-state:running;animation-play-state:running}.cjk-running-area.cjk-running-area-top{z-index:2}.cjk-running-area.cjk-running-area-bottom{z-index:1}.cjk-running-area>li{width:.8em;height:1.25em;line-height:1.25em;text-align:center}.cjk-running-area-bottom.cjk-hidden>li,.cjk-running-area-top.cjk-hidden>li{visibility:hidden}@-webkit-keyframes runningAnimation{0%{top:0}to{top:-12.5em}}@keyframes runningAnimation{0%{top:0}to{top:-12.5em}}@-webkit-keyframes reverseRunningAnimation{0%{top:-12.5em}to{top:0}}@keyframes reverseRunningAnimation{0%{top:-12.5em}to{top:0}}@-webkit-keyframes runningAnimation1{0%{top:0}to{top:-1.25em}}@keyframes runningAnimation1{0%{top:0}to{top:-1.25em}}@-webkit-keyframes reverseRunningAnimation1{0%{top:-1.25em}to{top:0}}@keyframes reverseRunningAnimation1{0%{top:-1.25em}to{top:0}}@-webkit-keyframes runningAnimation2{0%{top:0}to{top:-2.5em}}@keyframes runningAnimation2{0%{top:0}to{top:-2.5em}}@-webkit-keyframes reverseRunningAnimation2{0%{top:-2.5em}to{top:0}}@keyframes reverseRunningAnimation2{0%{top:-2.5em}to{top:0}}@-webkit-keyframes runningAnimation3{0%{top:0}to{top:-3.75em}}@keyframes runningAnimation3{0%{top:0}to{top:-3.75em}}@-webkit-keyframes reverseRunningAnimation3{0%{top:-3.75em}to{top:0}}@keyframes reverseRunningAnimation3{0%{top:-3.75em}to{top:0}}@-webkit-keyframes runningAnimation4{0%{top:0}to{top:-5em}}@keyframes runningAnimation4{0%{top:0}to{top:-5em}}@-webkit-keyframes reverseRunningAnimation4{0%{top:-5em}to{top:0}}@keyframes reverseRunningAnimation4{0%{top:-5em}to{top:0}}@-webkit-keyframes runningAnimation5{0%{top:0}to{top:-6.25em}}@keyframes runningAnimation5{0%{top:0}to{top:-6.25em}}@-webkit-keyframes reverseRunningAnimation5{0%{top:-6.25em}to{top:0}}@keyframes reverseRunningAnimation5{0%{top:-6.25em}to{top:0}}@-webkit-keyframes runningAnimation6{0%{top:0}to{top:-7.5em}}@keyframes runningAnimation6{0%{top:0}to{top:-7.5em}}@-webkit-keyframes reverseRunningAnimation6{0%{top:-7.5em}to{top:0}}@keyframes reverseRunningAnimation6{0%{top:-7.5em}to{top:0}}@-webkit-keyframes runningAnimation7{0%{top:0}to{top:-8.75em}}@-webkit-keyframes reverseRunningAnimation7{0%{top:-8.75em}to{top:0}}@keyframes runningAnimation7{0%{top:0}to{top:-8.75em}}@keyframes reverseRunningAnimation7{0%{top:-8.75em}to{top:0}}@-webkit-keyframes runningAnimation8{0%{top:0}to{top:-10em}}@keyframes runningAnimation8{0%{top:0}to{top:-10em}}@-webkit-keyframes reverseRunningAnimation8{0%{top:-10em}to{top:0}}@keyframes reverseRunningAnimation8{0%{top:-10em}to{top:0}}@-webkit-keyframes runningAnimation9{0%{top:0}to{top:-11.25em}}@keyframes runningAnimation9{0%{top:0}to{top:-11.25em}}@-webkit-keyframes reverseRunningAnimation9{0%{top:-11.25em}to{top:0}}@keyframes reverseRunningAnimation9{0%{top:-11.25em}to{top:0}}", ""]);

// exports


/***/ }),

/***/ "f6fd":
/***/ (function(module, exports) {

// document.currentScript polyfill by Adam Miller

// MIT license

(function(document){
  var currentScript = "currentScript",
      scripts = document.getElementsByTagName('script'); // Live NodeList collection

  // If browser needs currentScript polyfill, add get currentScript() to the document object
  if (!(currentScript in document)) {
    Object.defineProperty(document, currentScript, {
      get: function(){

        // IE 6-10 supports script readyState
        // IE 10+ support stack trace
        try { throw new Error(); }
        catch (err) {

          // Find the second match for the "at" string to get file src url from stack.
          // Specifically works with the format of stack traces in IE.
          var i, res = ((/.*at [^\(]*\((.*):.+:.+\)$/ig).exec(err.stack) || [false])[1];

          // For all scripts on the page, if src matches or if ready state is interactive, return the script tag
          for(i in scripts){
            if(scripts[i].src == res || scripts[i].readyState == "interactive"){
              return scripts[i];
            }
          }

          // If no match, return null
          return null;
        }
      }
    });
  }
})(document);


/***/ }),

/***/ "fb15":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/setPublicPath.js
// This file is imported into lib/wc client bundles.

if (typeof window !== 'undefined') {
  if (true) {
    __webpack_require__("f6fd")
  }

  var i
  if ((i = window.document.currentScript) && (i = i.src.match(/(.+\/)[^/]+\.js(\?.*)?$/))) {
    __webpack_require__.p = i[1] // eslint-disable-line
  }
}

// Indicate to webpack that this file can be concatenated
/* harmony default export */ var setPublicPath = (null);

// CONCATENATED MODULE: ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"83fce62e-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./packages/vue-running-number.vue?vue&type=template&id=071a491e&
var render = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"cjk-running-component"},[_c('div',{ref:"cjk-running-container",staticClass:"cjk-running-container",style:(("font-size: " + (0.8*_vm.size) + "px;"))})])}
var staticRenderFns = []


// CONCATENATED MODULE: ./packages/vue-running-number.vue?vue&type=template&id=071a491e&

// CONCATENATED MODULE: ./node_modules/cache-loader/dist/cjs.js??ref--12-0!./node_modules/thread-loader/dist/cjs.js!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./packages/vue-running-number.vue?vue&type=script&lang=js&
//
//
//
//
//
//
//
//
//
//
/* harmony default export */ var vue_running_numbervue_type_script_lang_js_ = ({
  name: 'VueRunningNumber',
  components: {},
  props: {
    size: {
      type: Number,
      default: 40
    },
    inNumber: {
      type: Number,
      default: 0
    },
    duration: {
      type: Number,
      default: 2000
    },
    isSplit: {
      type: Boolean,
      default: false
    }
  },
  data: function data() {
    return {
      numLists: ['<li>0</li><li>1</li><li>2</li><li>3</li><li>4</li><li>5</li><li>6</li><li>7</li><li>8</li><li>9</li><li>0</li>', '<li>1</li><li>2</li><li>3</li><li>4</li><li>5</li><li>6</li><li>7</li><li>8</li><li>9</li><li>0</li><li>1</li>', '<li>2</li><li>3</li><li>4</li><li>5</li><li>6</li><li>7</li><li>8</li><li>9</li><li>0</li><li>1</li><li>2</li>', '<li>3</li><li>4</li><li>5</li><li>6</li><li>7</li><li>8</li><li>9</li><li>0</li><li>1</li><li>2</li><li>3</li>', '<li>4</li><li>5</li><li>6</li><li>7</li><li>8</li><li>9</li><li>0</li><li>1</li><li>2</li><li>3</li><li>4</li>', '<li>5</li><li>6</li><li>7</li><li>8</li><li>9</li><li>0</li><li>1</li><li>2</li><li>3</li><li>4</li><li>5</li>', '<li>6</li><li>7</li><li>8</li><li>9</li><li>0</li><li>1</li><li>2</li><li>3</li><li>4</li><li>5</li><li>6</li>', '<li>7</li><li>8</li><li>9</li><li>0</li><li>1</li><li>2</li><li>3</li><li>4</li><li>5</li><li>6</li><li>7</li>', '<li>8</li><li>9</li><li>0</li><li>1</li><li>2</li><li>3</li><li>4</li><li>5</li><li>6</li><li>7</li><li>8</li>', '<li>9</li><li>0</li><li>1</li><li>2</li><li>3</li><li>4</li><li>5</li><li>6</li><li>7</li><li>8</li><li>9</li>'],
      minusNumLists: ['<li>0</li><li>9</li><li>8</li><li>7</li><li>6</li><li>5</li><li>4</li><li>3</li><li>2</li><li>1</li><li>0</li>', '<li>1</li><li>0</li><li>9</li><li>8</li><li>7</li><li>6</li><li>5</li><li>4</li><li>3</li><li>2</li><li>1</li>', '<li>2</li><li>1</li><li>0</li><li>9</li><li>8</li><li>7</li><li>6</li><li>5</li><li>4</li><li>3</li><li>2</li>', '<li>3</li><li>2</li><li>1</li><li>0</li><li>9</li><li>8</li><li>7</li><li>6</li><li>5</li><li>4</li><li>3</li>', '<li>4</li><li>3</li><li>2</li><li>1</li><li>0</li><li>9</li><li>8</li><li>7</li><li>6</li><li>5</li><li>4</li>', '<li>5</li><li>4</li><li>3</li><li>2</li><li>1</li><li>0</li><li>9</li><li>8</li><li>7</li><li>6</li><li>5</li>', '<li>6</li><li>5</li><li>4</li><li>3</li><li>2</li><li>1</li><li>0</li><li>9</li><li>8</li><li>7</li><li>6</li>', '<li>7</li><li>6</li><li>5</li><li>4</li><li>3</li><li>2</li><li>1</li><li>0</li><li>9</li><li>8</li><li>7</li>', '<li>8</li><li>7</li><li>6</li><li>5</li><li>4</li><li>3</li><li>2</li><li>1</li><li>0</li><li>9</li><li>8</li>', '<li>9</li><li>8</li><li>7</li><li>6</li><li>5</li><li>4</li><li>3</li><li>2</li><li>1</li><li>0</li><li>9</li>'],
      htmlStr: '',
      hisNumber: 0
    };
  },
  watch: {
    inNumber: function inNumber(v) {
      this.startCompute(Number(this.hisNumber), Number(v), this.duration);
    }
  },
  mounted: function mounted() {
    this.startCompute(Number(this.hisNumber), Number(this.inNumber), this.duration);
  },
  methods: {
    startCompute: function startCompute(start, end, duration) {
      var _this = this;

      //开始计算
      if (start >= 0 && end >= 0) {
        this.computeRunningArg(start, Number(end), duration);
      } else if (start <= 0 && end <= 0) {
        this.computeRunningArg(start, Number(end), duration, true);
      } else if (start > 0 && end < 0) {
        var dS = Math.ceil(duration * Math.abs(start) / (Math.abs(start) + Math.abs(end)));
        var dE = duration - dS > 10 ? duration - dS : 10;
        this.computeRunningArg(start, 0, dS);
        setTimeout(function () {
          _this.computeRunningArg(0, Number(end), dE, true);
        }, dS);
      } else if (start < 0 && end > 0) {
        var _dS = Math.ceil(duration * Math.abs(start) / (Math.abs(start) + Math.abs(end)));

        var _dE = duration - _dS > 10 ? duration - _dS : 10;

        this.computeRunningArg(start, 0, _dS, true);
        setTimeout(function () {
          _this.computeRunningArg(0, Number(end), _dE);
        }, _dS);
      }
    },
    computeRunningArg: function computeRunningArg(sNum, eNum, inDuration, isHaveMinus) {
      var _this2 = this;

      //计算滚动动画的相关参数
      if (sNum === eNum && eNum === 0) {
        this.$refs['cjk-running-container'].innerHTML = '<div class="cjk-number-box"><ul class="cjk-running-area"><li>0</li></ul></div>';
      }

      if (sNum === eNum) return;
      var absSnum = Math.abs(sNum);
      var absEnum = Math.abs(eNum);
      var forTimes = (absEnum > absSnum ? absEnum : absSnum).toString().replace('.', '').length;
      var pointObj = {
        index: 0,
        endRemovePointer: absEnum.toString().indexOf('.') === -1 ? true : false
      };
      var rSnum = this.getRelativeNum(absSnum.toString(), absEnum.toString(), pointObj);
      var rEnum = this.getRelativeNum(absEnum.toString(), absSnum.toString());
      var sNumArr = rSnum.split('').reverse();
      var eNumArr = rEnum.split('').reverse();
      var offset = Math.abs(rEnum - rSnum);
      var isDown = eNum - sNum >= 0 ? false : true;
      this.htmlStr = '';

      for (var i = forTimes - 1; i >= 0; i--) {
        var start = sNumArr[i] ? sNumArr[i] : 0;
        var end = eNumArr[i] ? eNumArr[i] : 0;
        var times = Math.floor(offset / Math.pow(10, i + 1));
        if (times === 12) times = 11; //times为12时，当时测试使用得chrome浏览器视觉效果有波动，其他值都好，具体不知道为什么

        times = times < 20 ? times : Math.ceil(inDuration / 10);
        var delay = inDuration % times;
        var duration = times === 0 ? inDuration : (inDuration - delay) / times;
        var isSplit = i > pointObj.index + 2 && i % 3 === 0;
        var isPointer = i === pointObj.index && i != 0 ? true : false;
        this.createRunningHtml(isHaveMinus ? this.minusNumLists : this.numLists, Number(start), Number(end), duration / 1000, times, delay / 1000, isDown, this.isSplit && isSplit, isPointer);
      }

      this.startRunning(Math.floor(inDuration / 2), isHaveMinus, pointObj.endRemovePointer);
      this.$nextTick(function () {
        _this2.hisNumber = _this2.inNumber;
      });
    },
    getRelativeNum: function getRelativeNum(num, rNum, pointObj) {
      //获取相对大小数字，主要处理小数情况
      var hNum = num.split('.')[0];
      var fNum = num.split('.')[1] ? num.split('.')[1] : '';
      var hRnum = rNum.split('.')[0];
      var fRnum = rNum.split('.')[1] ? rNum.split('.')[1] : '';
      var newHNum = hNum;
      var newFNum = fNum;

      if (fRnum.length > fNum.length) {
        for (var i = 0; i < fRnum.length - fNum.length; i++) {
          newFNum += '0';
        }
      }

      if (hRnum.length > hNum.length) {
        for (var _i = 0; _i < hRnum.length - hNum.length; _i++) {
          newHNum = '0' + newHNum;
        }
      }

      if (pointObj && newFNum) pointObj.index = newFNum.length;
      return newHNum + newFNum;
    },
    startRunning: function startRunning(chageStyleTime, isHaveMinus, endRemovePointer) {
      var _this3 = this;

      // 开始运行当前动画
      this.$refs['cjk-running-container'].innerHTML = this.htmlStr;

      if (isHaveMinus) {
        this.addCls(this.$refs['cjk-running-container'], 'cjk-minus');
      } else {
        this.removeCls(this.$refs['cjk-running-container'], 'cjk-minus');
      }

      setTimeout(function () {
        var topRunningArrEl = document.querySelectorAll('.cjk-running-area-top');
        var bottomRunningArrEl = document.querySelectorAll('.cjk-running-area-bottom');

        _this3.changeDomCls(topRunningArrEl, bottomRunningArrEl, 'cjk-hidden');
      }, chageStyleTime);
      setTimeout(function () {
        _this3.endCallBack(endRemovePointer);
      }, chageStyleTime * 2);
    },
    endCallBack: function endCallBack(endRemovePointer) {
      //一次总动画执行完后执行该函数，动态移动隐藏数字开头的0
      //const numberCls = Array.from(document.querySelectorAll('.cjk-number-box'));
      var numberCls = [];
      var isDelRight = false;
      document.querySelectorAll('.cjk-number-box').forEach(function (el) {
        numberCls.push(el);
        if (el.getAttribute('class').indexOf('cjk-pointer') !== -1) isDelRight = true;
      });
      this.hiddenZero(numberCls);
      if (isDelRight) this.hiddenZero(numberCls.reverse());
      if (endRemovePointer) this.removeCls(document.querySelector('.cjk-number-box.cjk-pointer'), 'cjk-pointer');
    },
    hiddenZero: function hiddenZero(numberCls) {
      //隐藏左右侧得0
      var isHidden = true;
      numberCls.forEach(function (el) {
        if (numberCls.length === 1) return;

        if (el.getAttribute('endNum') === '0' && el.getAttribute('class').indexOf('cjk-pointer') === -1) {
          if (isHidden) {
            el.style.width = '0px';
            el.style.overflow = 'hidden';
          }
        } else {
          isHidden = false;
        }
      });
    },
    changeDomCls: function changeDomCls(tops, bottoms, cls) {
      var _this4 = this;

      //批量移除tops元素的cls，增加bottoms元素的cls
      tops.forEach(function (v) {
        _this4.removeCls(v, cls);
      });
      bottoms.forEach(function (v) {
        _this4.addCls(v, cls);
      });
    },
    addCls: function addCls(el, cls) {
      //给元素增加class
      if (!el) return;
      var allCls = el.getAttribute('class');
      if (allCls.indexOf(cls) === -1) el.setAttribute('class', "".concat(allCls, " ").concat(cls));
    },
    removeCls: function removeCls(el, cls) {
      //给元素移除class
      if (!el) return;
      var allCls = el.getAttribute('class');
      if (allCls.indexOf(cls) !== -1) el.setAttribute('class', allCls.replace(cls, ''));
    },
    createRunningHtml: function createRunningHtml(numLists, start, end, duration, times, delay, isDown, isSplit, isPointer) {
      //创建当前位数字的滚动特效所需的html
      var animation = isDown ? 'reverseRunningAnimation' : 'runningAnimation';
      var splitCls = isSplit ? ' cjk-split' : '';
      var pointerCls = isPointer ? ' cjk-pointer' : '';

      if (times === 0) {
        if (start === end) {
          this.htmlStr += "<div class=\"cjk-number-box".concat(splitCls).concat(pointerCls, "\" endNum=\"").concat(end, "\">\n        <div><ul class=\"cjk-running-area\"><li>").concat(end, "</li></ul></div></div>");
        } else {
          this.htmlStr += "<div class=\"cjk-number-box".concat(splitCls).concat(pointerCls, "\" endNum=\"").concat(end, "\">\n        <div>\n        <ul class=\"cjk-running-area cjk-running-area-top\" style=\"animation-name:").concat(animation).concat(Math.abs(end - start).toString(), ";animation-duration:").concat(duration, "s;animation-iteration-count: 1;\">").concat(numLists[isDown ? end : start], "</ul>\n        </div>\n        </div>");
        }

        return;
      }

      this.htmlStr += "<div class=\"cjk-number-box".concat(splitCls).concat(pointerCls, "\" endNum=\"").concat(end, "\">\n        <div>\n        <ul class=\"cjk-running-area cjk-running-area-top cjk-hidden\" style=\"animation-delay:").concat(delay, "s;animation-name:").concat(animation, ";animation-duration:").concat(duration, "s;animation-iteration-count: ").concat(times, ";\">").concat(numLists[end], "</ul>\n        <ul class=\"cjk-running-area cjk-running-area-bottom\" style=\"animation-name:").concat(animation, ";animation-duration:").concat(duration, "s;animation-iteration-count: ").concat(times, ";\">").concat(numLists[start], "</ul>\n        </div>\n        </div>");
    }
  }
});
// CONCATENATED MODULE: ./packages/vue-running-number.vue?vue&type=script&lang=js&
 /* harmony default export */ var packages_vue_running_numbervue_type_script_lang_js_ = (vue_running_numbervue_type_script_lang_js_); 
// EXTERNAL MODULE: ./packages/vue-running-number.vue?vue&type=style&index=0&lang=css&
var vue_running_numbervue_type_style_index_0_lang_css_ = __webpack_require__("bc3b");

// CONCATENATED MODULE: ./node_modules/vue-loader/lib/runtime/componentNormalizer.js
/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file (except for modules).
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

function normalizeComponent (
  scriptExports,
  render,
  staticRenderFns,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier, /* server only */
  shadowMode /* vue-cli only */
) {
  // Vue.extend constructor export interop
  var options = typeof scriptExports === 'function'
    ? scriptExports.options
    : scriptExports

  // render functions
  if (render) {
    options.render = render
    options.staticRenderFns = staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = 'data-v-' + scopeId
  }

  var hook
  if (moduleIdentifier) { // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = shadowMode
      ? function () { injectStyles.call(this, this.$root.$options.shadowRoot) }
      : injectStyles
  }

  if (hook) {
    if (options.functional) {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functioal component in vue file
      var originalRender = options.render
      options.render = function renderWithStyleInjection (h, context) {
        hook.call(context)
        return originalRender(h, context)
      }
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate
      options.beforeCreate = existing
        ? [].concat(existing, hook)
        : [hook]
    }
  }

  return {
    exports: scriptExports,
    options: options
  }
}

// CONCATENATED MODULE: ./packages/vue-running-number.vue






/* normalize component */

var component = normalizeComponent(
  packages_vue_running_numbervue_type_script_lang_js_,
  render,
  staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* harmony default export */ var vue_running_number = (component.exports);
// CONCATENATED MODULE: ./packages/index.js
 // 为组件提供 install 安装方法，供按需引入

vue_running_number.install = function (Vue) {
  Vue.component(vue_running_number.name, vue_running_number);
};

/* harmony default export */ var packages_0 = (vue_running_number);
// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/entry-lib.js


/* harmony default export */ var entry_lib = __webpack_exports__["default"] = (packages_0);



/***/ })

/******/ });
});
//# sourceMappingURL=index.umd.js.map